﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.IO.Ports;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Runtime.InteropServices;
using System.Diagnostics;
using System.Text.RegularExpressions;
using Microsoft.Win32;

namespace EPT_System_Demo
{
    public partial class EPT_System_Demo : Form
    {
        public EPT_System_Demo()
        {
            InitializeComponent();

/*            btnBlkCompare8.Enabled = false;
            btnBlkCompare16.Enabled = false;
            btnUserBlk.Enabled = false;
            btnResetBlock.Enabled = false;
            btnStopBlockTransfer.Enabled = false;
            btnBlockSendRst.Enabled = false;
*/            btnWriteByte.Enabled = false;
            tbWriteMultiByte.Enabled = false;
            btnWriteMultiByte.Enabled = false;
            btnTransferReset.Enabled = false;
            btnResetTriggerOut.Enabled = false;

            for (int i = 0; i < EPTTransmitDevice.Length; ++i)
            {
                EPTTransmitDevice[i] = new Transfer();
            }

            //rbtnRepitions.Checked = true;
            //rbtnInfinite.Checked = false;
        }

        //Sting array to hold the Port names that match the VID = "403 PID = "6001"
        public string[] MatchingComPortList = new string[10];

        // Local Serial Port parameters From Properties Page
        public static string PortName = "COM1";
        public static string BaudRate = "2400";
        public static string DataBits = "8";
        public static string vParity = "None";
        public static string StopBits = "1";
        public static string pHandshake = "None";

        // Serial port send variables
        byte[] PutBuff;
        //char[] PutChar;

        //Index to store device selection
        //Int32 device_index;

        // EPT EndTerm parameters
        public const byte TRANSFER_ENDTERM_1 = 0x01;
        public const byte TRANSFER_ENDTERM_2 = 0x02;
        public const byte TRANSFER_ENDTERM_3 = 0x03;
        public const byte TRANSFER_ENDTERM_4 = 0x04;
        public const byte TRANSFER_ENDTERM_5 = 0x05;
        public const byte TRANSFER_ENDTERM_6 = 0x06;
        public const byte TRANSFER_ENDTERM_7 = 0x07;

        //Parameters for EPT Receive object Trigger
        public const byte TRIGGER_IN_BYTE_1 = 0x01;
        public const byte TRIGGER_IN_BYTE_2 = 0x02;
        public const byte TRIGGER_IN_BYTE_4 = 0x04;
        public const byte TRIGGER_IN_BYTE_8 = 0x08;
        public const byte TRIGGER_IN_BYTE_10 = 0x10;
        public const byte TRIGGER_IN_BYTE_20 = 0x20;
        public const byte TRIGGER_IN_BYTE_40 = 0x40;
        public const byte TRIGGER_IN_BYTE_80 = 0x80;

        //Parameters for EPT Receive object Transfer byte
        public const byte TRANSFER_IN_ADDRESS_1 = 0x1;
        public const byte TRANSFER_IN_ADDRESS_2 = 0x2;

        //Parameters for EPT Receive object Block
        public const byte BLOCK_IN_ADDRESS_1 = 0x1;
        public const byte BLOCK_IN_ADDRESS_2 = 0x2;

        //Transfer Parameters
        public const byte CONTROL_REG_RESET = 0x00;
        public const byte TRANSFER_LOOPBACK = 0x01;
        public const byte BLOCK_LOOPBACK = 0x02;
        public const byte LOAD_IMAGE_TO_BUFFER = 0x04;
        public const byte LOAD_FACE_IMAGE = 0x08;
        public const byte RANDOM_IMAGE = 0x10;
        public const byte SET_SHIFT_COUNT_UP = 0x40;
        public const byte SET_SHIFT_COUNT_DOWN = 0x50;
        public const byte SET_STATIC_IMAGE = 0x70;
        public const byte SET_SHIFT_RIGHT_IMAGE = 0x90;
        public const byte SET_SHIFT_LEFT_IMAGE = 0xa0;

        //Create a Receive object of the Transfer Class.
        Transfer EPTReceiveData = new Transfer();

        //Create an array of the Transfer Class for device
        Transfer[] EPTTransmitDevice = new Transfer[8];

        //Eight Byte block for Block Transfers
        //byte[] block_in_payload;

        //Block Transfer and Loop counter
        //uint BlockCount = 0;
        //uint LoopCount = 0;

        //Block Transfer Control 
        //public bool BlockTransferInfinite = false;
        //public bool BlockTransferReps = false;
        //public bool BlockTransferStop = false;

        //String to Hold payload
        public String PayloadString = "";

        //Value to hold the errors in Block Compares
        public int BlockErrorCount = 0;
        public bool EnableLogFile = false;

        //Hold the previous status of the LED
        //int LEDStatusPrevious = 0;

        //LED Status Register
        //byte LEDStatus;

        //Parameters
        public const int SELECT_RANDOM = 1;
        public const int SELECT_SHIFT_LEFT = 2;
        public const int SELECT_SHIFT_RIGHT = 3;
        public const int SELECT_COUNT_UP = 4;
        public const int SELECT_COUNT_DOWN = 5;

        //Parameters for EPT Receive object
        public const byte TRANSFER_OUT_ADDRESS_1 = 0x1;
        public const byte TRANSFER_OUT_ADDRESS_2 = 0x2;

        //Parameters
        public const byte userLEDAddress = 0x01;
        public const byte userByteAddress = 0x02;
        //Create an array of the Transfer Class for device
        /*        Transfer[] EPTTransmitDevice = new Transfer[8];
        */

        //GPIO Registers for external Connectors
        public byte gpioXIO1;
        public byte gpioXIO2;
        public byte gpioXIO3;
        public byte gpioXIO4;
        public byte gpioXIO5;
        public byte gpioXIO6;
        public byte gpioXIO7;
        public byte gpioXIO8;
        public bool gpioInfiniteLoopFlag = false;
        public bool gpioSingleLoopFlag = true;
        public bool gpioInfiniteLoopEnabled = false;


        private void EPT_System_Demo_Load(object sender, System.EventArgs e)
        {

            //String buffer
            String PortText = "";

            //Index registers
            int Index = 0;

            // Call the List Devices function
            List<string> names = ComPortNames("0403", "6015");

            // Get a list of serial port names.
            string[] ports;
            ports = SerialPort.GetPortNames();


            if (names.Count > 0)
            {
                foreach (String port in ports)
                {
                    //Compare port name with the found VID/PID 
                    //combinations. Add them to Matching port list
                    //and comboDevList
                    if (names.Contains(port))
                    {
                        MatchingComPortList[Index] = port;

                        PortText = "CycloFlex Board " + Index++;
                        cmbDevList.Items.Add(PortText);
                    }
                }
            }
            else
                MessageBox.Show("No CycloFlex Boards found!");

            //Set Label to blank
            lblDeviceConnected.Text = " ";



        }

        private void SetButtonEnables_Open()
        {

            string s2, s3;

            //Byte Transfer Buttons
            btnWriteByte.Enabled = true;
            tbWriteMultiByte.Enabled = true;
            btnWriteMultiByte.Enabled = true;

            //Block Transfer Buttons
            /*            btnBlkCompare8.Enabled = true;
                        btnBlkCompare16.Enabled = true;
                        btnUserBlk.Enabled = true;
                        btnBlockSendRst.Enabled = true;
                        btnResetBlock.Enabled = true;
                        btnStopBlockTransfer.Enabled = true;
            */
            btnTransferReset.Enabled = true;
            btnResetTriggerOut.Enabled = true;

            // Marks the device as closed in the GUI
            btnOpenDevice.Enabled = false;
            btnCloseDevice.Enabled = true;

            btnGPIOXIO1_8.Enabled = true;
            btnGPIOXIO1_7.Enabled = true;
            btnGPIOXIO1_6.Enabled = true;
            btnGPIOXIO1_5.Enabled = true;
            btnGPIOXIO1_4.Enabled = true;
            btnGPIOXIO1_3.Enabled = true;
            btnGPIOXIO1_2.Enabled = true;
            btnGPIOXIO1_1.Enabled = true;

            btnGPIOXIO2_8.Enabled = true;
            btnGPIOXIO2_7.Enabled = true;
            btnGPIOXIO2_6.Enabled = true;
            btnGPIOXIO2_5.Enabled = true;
            btnGPIOXIO2_4.Enabled = true;
            btnGPIOXIO2_3.Enabled = true;
            btnGPIOXIO2_2.Enabled = true;
            btnGPIOXIO2_1.Enabled = true;

            btnGPIOXIO3_8.Enabled = true;
            btnGPIOXIO3_7.Enabled = true;
            btnGPIOXIO3_6.Enabled = true;
            btnGPIOXIO3_5.Enabled = true;
            btnGPIOXIO3_4.Enabled = true;
            btnGPIOXIO3_3.Enabled = true;
            btnGPIOXIO3_2.Enabled = true;
            btnGPIOXIO3_1.Enabled = true;

            btnGPIOXIO4_8.Enabled = true;
            btnGPIOXIO4_7.Enabled = true;
            btnGPIOXIO4_6.Enabled = true;
            btnGPIOXIO4_5.Enabled = true;
            btnGPIOXIO4_4.Enabled = true;
            btnGPIOXIO4_3.Enabled = true;
            btnGPIOXIO4_2.Enabled = true;
            btnGPIOXIO4_1.Enabled = true;

            btnGPIOLegendUp.Enabled = false;
            btnGPIOLegendLo.Enabled = false;


            s2 = char.ConvertFromUtf32(0x2191);
            btnGPIOLegendLo.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
            btnGPIOLegendLo.BackColor = Color.Red;

            s3 = char.ConvertFromUtf32(0x2193);
            btnGPIOLegendUp.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
            btnGPIOLegendUp.BackColor = Color.DodgerBlue;

            this.Invoke(new MethodInvoker(delegate () { btnGPIOLegendLo.Text = s2; }));
            this.Invoke(new MethodInvoker(delegate () { btnGPIOLegendUp.Text = s3; }));
        }

        private void SetButtonEnables_Close()
        {
/*            btnBlkCompare8.Enabled = true;
            btnBlkCompare16.Enabled = true;
            btnStopBlockTransfer.Enabled = true;
            btnResetBlock.Enabled = true;
            btnBlockSendRst.Enabled = true;
            tbBlockSend.Enabled = true;
*/            btnResetTriggerOut.Enabled = true;
            gbTriggerOut.Enabled = true;
            gbTransferControl.Enabled = true;
            btnTransferReset.Enabled = true;

            // Make sure the device is closed
            if (!FT220xSerialPort.IsOpen)
            {
/*                btnBlkCompare8.Enabled = false;
                btnBlkCompare16.Enabled = false;
                btnUserBlk.Enabled = false;
                btnBlockSendRst.Enabled = false;
                btnResetBlock.Enabled = false;
                btnStopBlockTransfer.Enabled = false;
*/                btnWriteByte.Enabled = false;
                tbWriteMultiByte.Enabled = false;
                btnWriteMultiByte.Enabled = false;
                btnTransferReset.Enabled = false;
                btnResetTriggerOut.Enabled = false;
            }

            // Marks the device as closed in the GUI
            btnOpenDevice.Enabled = true;
            btnCloseDevice.Enabled = false;

            lblDeviceConnected.Text = "Dis-Connected";


            btnGPIOXIO1_8.Enabled = false;
            btnGPIOXIO1_7.Enabled = false;
            btnGPIOXIO1_6.Enabled = false;
            btnGPIOXIO1_5.Enabled = false;
            btnGPIOXIO1_4.Enabled = false;
            btnGPIOXIO1_3.Enabled = false;
            btnGPIOXIO1_2.Enabled = false;
            btnGPIOXIO1_1.Enabled = false;

            btnGPIOXIO2_8.Enabled = false;
            btnGPIOXIO2_7.Enabled = false;
            btnGPIOXIO2_6.Enabled = false;
            btnGPIOXIO2_5.Enabled = false;
            btnGPIOXIO2_4.Enabled = false;
            btnGPIOXIO2_3.Enabled = false;
            btnGPIOXIO2_2.Enabled = false;
            btnGPIOXIO2_1.Enabled = false;

            btnGPIOXIO3_8.Enabled = false;
            btnGPIOXIO3_7.Enabled = false;
            btnGPIOXIO3_6.Enabled = false;
            btnGPIOXIO3_5.Enabled = false;
            btnGPIOXIO3_4.Enabled = false;
            btnGPIOXIO3_3.Enabled = false;
            btnGPIOXIO3_2.Enabled = false;
            btnGPIOXIO3_1.Enabled = false;

            btnGPIOXIO4_8.Enabled = false;
            btnGPIOXIO4_7.Enabled = false;
            btnGPIOXIO4_6.Enabled = false;
            btnGPIOXIO4_5.Enabled = false;
            btnGPIOXIO4_4.Enabled = false;
            btnGPIOXIO4_3.Enabled = false;
            btnGPIOXIO4_2.Enabled = false;
            btnGPIOXIO4_1.Enabled = false;


        }

        private void cmbDevList_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Get Port name from Combo Box
            PortName = MatchingComPortList[cmbDevList.SelectedIndex];
        }


        
        private void btnOpenDevice_Click(object sender, EventArgs e)
        {
            OpenSerialPort1();
            if (FT220xSerialPort.IsOpen)
            {
                lblDeviceConnected.Text = "Device Connected";
                SetButtonEnables_Open();
            }
        }

        private void btnCloseDevice_Click(object sender, EventArgs e)
        {
            if (FT220xSerialPort.IsOpen)
            {
                CloseSerialPort1();
                lblDeviceConnected.Text = "Dis-Connected";
                SetButtonEnables_Close();

            }
        }

        // Handle the "Byte" button
        private void btnWriteByte_Click(object sender, EventArgs e)
        {
            int address_to_device;
            int ibyte = Convert.ToInt32(tbNumBytes.Text);
            address_to_device = Convert.ToInt32(tbAddress.Text);

            EPT_AH_SendByte(userByteAddress, (byte)ibyte);

        }

        // Handle the "Multi Byte" button
        private void btnWriteMultiByte_Click(object sender, EventArgs e)
        {
            int i, address_to_device;
            byte dataToSend;
            address_to_device = Convert.ToInt32(tbAddress.Text);
            string[] result = tbWriteMultiByte.Text.Split(' ');
            for (i = 0; i < result.Length; i++)
            {
                dataToSend = (byte)Convert.ToInt32(result[i]);

                Thread t = new Thread(new ParameterizedThreadStart(multiByteSend));
                t.Start(dataToSend);
                Thread.Sleep(100);
            }

        }

        private void multiByteSend(object data)
        {
            EPT_AH_SendByte((byte)userByteAddress, (byte)data);
        }

        // Handle the "LoopBack" button
        private void btnLoopBack_Click(object sender, EventArgs e)
        {
            EPT_AH_SendTransferControlByte(userByteAddress, (byte)1);
        }

        //===============================
        //  Block Transfer Controls
        //===============================
        /*
        // Handle the radiobutton check for "Infinite" loop
        private void rbtnInfinite_CheckedChanged(object sender, EventArgs e)
        {
            BlockTransferInfinite = true;
            BlockTransferReps = false;
        }

        // Handle the radiobutton check for "Repetitions" loop
        private void rbtnRepitions_CheckedChanged(object sender, EventArgs e)
        {
            BlockTransferInfinite = false;
            BlockTransferReps = true;
        }

        // Handle the "Stop" block transfer button
        private void btnStopBlockTransfer_Click(object sender, EventArgs e)
        {
            BlockTransferStop = true;
        }


        // Handle user block update
        private void btnUserBlk_Click(object sender, EventArgs e)
        {
            int value;
            if (tbBlockSend.Text.Trim().Length == 0) return;
            int BlockAddress = (int)Convert.ToInt32(tbBlockRcvAddress.Text);
            uint BlockRepitions = (uint)Convert.ToInt32(tbRepitions.Text);
            if (EPTTransmitDevice[BlockAddress].TransferPending)
                return;

            int i, address_to_device;
            address_to_device = Convert.ToInt32(tbAddress.Text);
            string[] result = tbBlockSend.Text.Split(' ', '\n');
            block_in_payload = new byte[result.Length];

            for (i = 0; i < result.Length; i++)
            {
                int.TryParse(result[i], out value);
                block_in_payload[i] = Convert.ToByte(value);// Convert.ToByte(result[i]);
            }

            EPTTransmitDevice[BlockAddress].Address = BlockAddress;
            EPTTransmitDevice[BlockAddress].Length = result.Length;
            EPTTransmitDevice[BlockAddress].Repititions = BlockRepitions;
            BlockCount = 0;
            LoopCount = 0;
            BlockErrorCount = 0;
            BlockTransferStop = false;

            Thread t = new Thread(new ParameterizedThreadStart(BlockCompare));
            t.Start(BlockAddress);

        }

        // Handle the "BLOCK8" compare button
        private void btnBlkCompare8_Click(object sender, EventArgs e)
        {
            int BlockAddress = (int)Convert.ToInt32(tbBlockRcvAddress.Text);
            int BlockLength = 8;
            uint BlockRepitions = (uint)Convert.ToInt32(tbRepitions.Text);
            if (EPTTransmitDevice[BlockAddress].TransferPending)
                return;
            EPTTransmitDevice[BlockAddress].Address = BlockAddress;
            EPTTransmitDevice[BlockAddress].Length = BlockLength;
            EPTTransmitDevice[BlockAddress].Repititions = BlockRepitions;
            BlockCount = 0;
            LoopCount = 0;
            BlockErrorCount = 0;
            BlockTransferStop = false;
            block_in_payload = block_8_in_payload;

            Thread t = new Thread(new ParameterizedThreadStart(BlockWrite));
            t.Start(BlockAddress);
        }

        // Handle the "BLOCK16" compare button
        private void btnBlkCompare16_Click(object sender, EventArgs e)
        {
            int BlockAddress = (int)Convert.ToInt32(tbBlockRcvAddress.Text);
            int BlockLength = 16;
            uint BlockRepitions = (uint)Convert.ToInt32(tbRepitions.Text);
            if (EPTTransmitDevice[BlockAddress].TransferPending)
                return;
            EPTTransmitDevice[BlockAddress].Address = BlockAddress;
            EPTTransmitDevice[BlockAddress].Length = BlockLength;
            EPTTransmitDevice[BlockAddress].Repititions = BlockRepitions;
            BlockCount = 0;
            LoopCount = 0;
            BlockErrorCount = 0;
            BlockTransferStop = false;
            block_in_payload = block_16_in_payload;

            Thread t = new Thread(new ParameterizedThreadStart(BlockWrite));
            t.Start(BlockAddress);

        }

        // Handle the "BLOCK256" compare button
        private void btnBlkCompare256_Click(object sender, EventArgs e)
        {
            int BlockAddress = (int)Convert.ToInt32(tbBlockRcvAddress.Text);
            int BlockLength = 128;
            uint BlockRepitions = (uint)Convert.ToInt32(tbRepitions.Text);
            if (EPTTransmitDevice[BlockAddress].TransferPending)
                return;
            EPTTransmitDevice[BlockAddress].Address = BlockAddress;
            EPTTransmitDevice[BlockAddress].Length = BlockLength;
            EPTTransmitDevice[BlockAddress].Repititions = BlockRepitions;
            BlockCount = 0;
            LoopCount = 0;
            BlockErrorCount = 0;
            BlockTransferStop = false;
            block_in_payload = block_128_in_payload;

            Thread t = new Thread(new ParameterizedThreadStart(BlockWrite));
            t.Start(BlockAddress);

        }

        // Compare blocks of send/receive data
        public void BlockWrite(object data)
        {
            int BlockAddress = (int)data;
            byte[] cBuf = new Byte[EPTTransmitDevice[BlockAddress].Length];

            //Copy the data to the buffer to be transferred.
            Buffer.BlockCopy(block_in_payload, 0, cBuf, 0, EPTTransmitDevice[BlockAddress].Length);
            //Send the data to the Active Device
            EPT_AH_SendBlock((byte)EPTTransmitDevice[BlockAddress].Address, (byte)EPTTransmitDevice[BlockAddress].Length, cBuf);
            //Send the Block Loop Back command
            //Thread.Sleep(1);
            //EPT_AH_SendTransferControlByte(TRANSFER_ENDTERM_2, BLOCK_LOOPBACK);
            //Send the transfer FIFO to the Active Host command
            //Thread.Sleep(1);
            EPT_AH_SendTrigger((byte)128);

        }

        // Compare blocks of send/receive data
        public void BlockCompare(object data)
        {
            int BlockAddress = (int)System.Convert.ToUInt32(data);

            if ((EPTTransmitDevice[BlockAddress].Repititions > 0) & !EPTTransmitDevice[BlockAddress].TransferPending & !BlockTransferStop)
            {
                //Send the transfer FIFO to the Active Host command
                //Thread.Sleep(1);
                EPT_AH_SendTrigger((byte)128);

                if (BlockTransferInfinite)
                {
                    EPTTransmitDevice[BlockAddress].Repititions = 1;
                }
                else
                {
                    EPTTransmitDevice[BlockAddress].Repititions--;
                }
            }
        }

        */

        // Handle the "OK" button
        private void btnOk_Click(object sender, EventArgs e)
        {
            if (FT220xSerialPort.IsOpen)
            {
                CloseSerialPort1();
                lblDeviceConnected.Text = "Dis-Connected";
                SetButtonEnables_Close();

            }

            Application.Exit();
        }

        // Handle the "Cancel" button
        private void btnCancel_Click(object sender, EventArgs e)
        {
            if (FT220xSerialPort.IsOpen)
            {
                CloseSerialPort1();
                lblDeviceConnected.Text = "Dis-Connected";
                SetButtonEnables_Close();

            }

            Application.Exit();

        }

        // Handle clearing of the Block window
        /*private void btnResetBlock_Click(object sender, EventArgs e)
        {
            tbBlockRcv.Clear();
        }

        */
        // Parse incoming EPT data
        private void EPTParseReceive()
        {
            // Parse the command
            switch (EPTReceiveDevice.Command)
            {
                // This is a trigger command
                case TRIGGER_IN_COMMAND:
                    TriggerOutReceive();
                    break;
                // This is a single-byte transfer command
                case TRANSFER_IN_COMMAND:
                    TransferOutReceive();
                    break;
                // This is a data block transfer command
                case BLOCK_IN_COMMAND:
                    BlockInReceive();
                    break;
                default:
                    break;
            }
        }

        // Handle GUI update of an incoming trigger
        public void TriggerOutReceive()
        {
            switch (EPTReceiveDevice.Payload)
            {
                case 0x01:
                    lLabelSwitch1.Text = "Switch 1\n Pressed";
                    break;
                case 0x02:
                    lLabelSwitch2.Text = "Switch 2\n Pressed";
                    break;
                case 0x04:
                    lLabelSwitch1.Text = "";
                    lLabelSwitch2.Text = "";
                    break;
            }
        }

        // Handle GUI update of an incoming byte transfer
        public void TransferOutReceive()
        {
            switch (EPTReceiveDevice.Address)
            {
                case 0:
                    break;
                case 1:
                    break;
                case 2:
                    loopbackTransferByte();
                    break;
                default: break;
            }

        }

        private void loopbackTransferByte()
        {
            string WriteRcvChar = "";
            WriteRcvChar = String.Format("{0}", (int)EPTReceiveDevice.Payload);
            this.Invoke(new MethodInvoker(delegate () { tbDataBytes.AppendText(", " + WriteRcvChar); }));
        }

        // Handle clearing of byte data from the GUI when "Rst" is pressed
        private void btnTransferReset_Click(object sender, EventArgs e)
        {
            tbDataBytes.Clear();
        }

        private void btnResetTriggerOut_Click(object sender, EventArgs e)
        {
            EPT_AH_SendTransferControlByte(userByteAddress, (byte)8);
            Thread.Sleep(1);
            EPT_AH_SendTransferControlByte(userByteAddress, (byte)0);
            Thread.Sleep(1);

            lLabelSwitch1.Text = "";
            lLabelSwitch2.Text = "";

        }

        private void button1_Click(object sender, EventArgs e)
        {

        }

        private void btnShiftLeft_Click(object sender, EventArgs e)
        {
            //Send a Reset to Active Transfer Addr 1
            EPT_AH_SendByte((byte)1, (byte)0x08);

            //Send Trigger 1 to Complete the Reset
            EPT_AH_SendTrigger((byte)0x01);



            //Send the start Shift Left to the Control Register
            EPT_AH_SendTransferControlByte((byte)2, (byte)0x20);

            //Delay
            Thread.Sleep(1);

            //Send Trigger 6 to latch the Shift-Count Value
            EPT_AH_SendTrigger((byte)0x40);

            //Set the Button State so User can know which function is selected
            //SetLEDControlButtons(SELECT_SHIFT_LEFT);
        }

        private void btnShiftRight_Click(object sender, EventArgs e)
        {
            //LoadTimerValue();

            //Send a Reset to Active Transfer Addr 1
            EPT_AH_SendByte((byte)1, (byte)0x08);

            //Send Trigger 1 to Complete the Reset
            EPT_AH_SendTrigger((byte)0x01);

            //Send the start Shift Right to the Control Register
            EPT_AH_SendTransferControlByte((byte)2, (byte)0x30);

            //Delay
            Thread.Sleep(1);

            //Send Trigger 6 to latch the Shift-Count  Value
            EPT_AH_SendTrigger((byte)0x40);

            //Set the Button State so User can know which function is selected
            //SetLEDControlButtons(SELECT_SHIFT_RIGHT);

        }

        private void btnCountUp_Click(object sender, EventArgs e)
        {
            //LoadTimerValue();

            //Send a Reset to Active Transfer Addr 1
            EPT_AH_SendByte((byte)1, (byte)0x08);

            //Send Trigger 1 to Complete the Reset
            EPT_AH_SendTrigger((byte)0x01);

            //Send the start Shift Right to the Control Register
            EPT_AH_SendTransferControlByte((byte)2, (byte)0x40);

            //Delay
            Thread.Sleep(1);

            //Send Trigger 6 to latch the Shift-Count  Value
            EPT_AH_SendTrigger((byte)0x40);

            //Set the Button State so User can know which function is selected
            //SetLEDControlButtons(SELECT_COUNT_UP);

        }

        private void btnCountDown_Click(object sender, EventArgs e)
        {
            //LoadTimerValue();

            //Send a Reset to Active Transfer Addr 1
            EPT_AH_SendByte((byte)1, (byte)0x08);

            //Send Trigger 1 to Complete the Reset
            EPT_AH_SendTrigger((byte)0x01);


            //Send the start Shift Right to the Control Register
            EPT_AH_SendTransferControlByte((byte)2, (byte)0x50);

            //Delay
            Thread.Sleep(1);

            //Send Trigger 6 to latch the Shift-Count  Value
            EPT_AH_SendTrigger((byte)0x40);

            //Set the Button State so User can know which function is selected
            //SetLEDControlButtons(SELECT_COUNT_DOWN);

        }

        private void btnRGBLEDRed_Click(object sender, EventArgs e)
        {
            //Send the start Roll Command to the  Control Register
            EPT_AH_SendTransferControlByte((byte)2, (byte)0x0e);

            //Send the start Shift Right to the Control Register
            EPT_AH_SendTransferControlByte((byte)2, (byte)0x0b);

            EPT_AH_SendByte((byte)0x01, (byte)0x02);

            //Send Trigger 1 to latch the RGB LED color
            EPT_AH_SendTrigger((byte)0x01);

        }

        private void btnRGBLEDBlue_Click(object sender, EventArgs e)
        {
            //Send the start Roll Command to the  Control Register
            EPT_AH_SendTransferControlByte((byte)2, (byte)0x0e);

            //Send the start Shift Right to the Control Register
            EPT_AH_SendTransferControlByte((byte)2, (byte)0x0b);

            //Send the Assert BLue RGB via Transfer
            EPT_AH_SendByte((byte)1, (byte)0x01);

            //Send Trigger 1 to latch the RGB LED color
            EPT_AH_SendTrigger((byte)0x01);


        }

        private void btnRGBLEDGreen_Click(object sender, EventArgs e)
        {
            //Send the start Roll Command to the  Control Register
            EPT_AH_SendTransferControlByte((byte)2, (byte)0x0e);

            //Send the start Shift Right to the Control Register
            EPT_AH_SendTransferControlByte((byte)2, (byte)0x03);

            //Send the Assert Green RGB via Transfer
            EPT_AH_SendByte((byte)1, (byte)0x04);

            //Send Trigger 1 to latch the RGB LED color
            EPT_AH_SendTrigger((byte)0x01);


        }

        private void btnRGBLEDReset_Click(object sender, EventArgs e)
        {
            //Send the Assert Red RGB via Transfer
            EPT_AH_SendByte((byte)1, (byte)0x08);

            //Send Trigger 1 to latch the RGB LED color
            EPT_AH_SendTrigger((byte)0x01);


        }

        private void btnLEDDisplay_1_Click(object sender, EventArgs e)
        {
            byte ledDisplay_byte=0;
            string LEDDisplay_1 = cmbLEDDisplay_1.Text;

            switch(LEDDisplay_1)
            {
                case "A": 
                    ledDisplay_byte = 0xEE;
                    break;
                case "b":
                    ledDisplay_byte = 0x3E;
                    break;
                case "C":
                    ledDisplay_byte = 0x9C;
                    break;
                case "d":
                    ledDisplay_byte = 0x7A;
                    break;
                case "E":
                    ledDisplay_byte = 0x9E;
                    break;
                case "F":
                    ledDisplay_byte = 0x8E;
                    break;
                case "G":
                    ledDisplay_byte = 0xBC;
                    break;
                case "H":
                    ledDisplay_byte = 0x6E;
                    break;
                case "I":
                    ledDisplay_byte = 0x60;
                    break;
                case "J":
                    ledDisplay_byte = 0x70;
                    break;
                case "L":
                    ledDisplay_byte = 0x1C;
                    break;
                case "O":
                    ledDisplay_byte = 0xFC;
                    break;
                case "P":
                    ledDisplay_byte = 0xCE;
                    break;
                case "T":
                    ledDisplay_byte = 0x8C;
                    break;
                default:
                    ledDisplay_byte = 0x00;
                    break;
            }

            //Send the LED Display_1 via Transfer
            EPT_AH_SendByte((byte)3, (byte)ledDisplay_byte);

            //Send Trigger 2 to latch the LED Display_1
            EPT_AH_SendTrigger((byte)0x02);


        }

        private void btnLEDDisplay_2_Click(object sender, EventArgs e)
        {
            byte ledDisplay_byte = 0;
            string LEDDisplay_2 = cmbLEDDisplay_2.Text;

            switch (LEDDisplay_2)
            {
                case "A":
                    ledDisplay_byte = 0xEE;
                    break;
                case "b":
                    ledDisplay_byte = 0x3E;
                    break;
                case "C":
                    ledDisplay_byte = 0x9C;
                    break;
                case "d":
                    ledDisplay_byte = 0x7A;
                    break;
                case "E":
                    ledDisplay_byte = 0x9E;
                    break;
                case "F":
                    ledDisplay_byte = 0x8E;
                    break;
                case "G":
                    ledDisplay_byte = 0xBC;
                    break;
                case "H":
                    ledDisplay_byte = 0x6E;
                    break;
                case "I":
                    ledDisplay_byte = 0x60;
                    break;
                case "J":
                    ledDisplay_byte = 0x70;
                    break;
                case "L":
                    ledDisplay_byte = 0x1C;
                    break;
                case "O":
                    ledDisplay_byte = 0xFC;
                    break;
                case "P":
                    ledDisplay_byte = 0xCE;
                    break;
                case "T":
                    ledDisplay_byte = 0x8C;
                    break;
                default:
                    ledDisplay_byte = 0x00;
                    break;
            }

            //Send the LED Display_2 via Transfer
            EPT_AH_SendByte((byte)3, (byte)ledDisplay_byte);

            //Send Trigger 3 to latch the LED Display_2
            EPT_AH_SendTrigger((byte)0x04);



        }

        private void btnLEDDisplay_3_Click(object sender, EventArgs e)
        {
            byte ledDisplay_byte = 0;
            string LEDDisplay_3 = cmbLEDDisplay_3.Text;

            switch (LEDDisplay_3)
            {
                case "A":
                    ledDisplay_byte = 0xEE;
                    break;
                case "b":
                    ledDisplay_byte = 0x3E;
                    break;
                case "C":
                    ledDisplay_byte = 0x9C;
                    break;
                case "d":
                    ledDisplay_byte = 0x7A;
                    break;
                case "E":
                    ledDisplay_byte = 0x9E;
                    break;
                case "F":
                    ledDisplay_byte = 0x8E;
                    break;
                case "G":
                    ledDisplay_byte = 0xBC;
                    break;
                case "H":
                    ledDisplay_byte = 0x6E;
                    break;
                case "I":
                    ledDisplay_byte = 0x60;
                    break;
                case "J":
                    ledDisplay_byte = 0x70;
                    break;
                case "L":
                    ledDisplay_byte = 0x1C;
                    break;
                case "O":
                    ledDisplay_byte = 0xFC;
                    break;
                case "P":
                    ledDisplay_byte = 0xCE;
                    break;
                case "T":
                    ledDisplay_byte = 0x8C;
                    break;
                default:
                    ledDisplay_byte = 0x00;
                    break;
            }

            //Send the LED Display_3 via Transfer
            EPT_AH_SendByte((byte)3, (byte)ledDisplay_byte);

            //Send Trigger 4 to latch the LED Display_3
            EPT_AH_SendTrigger((byte)0x08);



        }

        private void btnLEDControl1_Click(object sender, EventArgs e)
        {
            //Send the Static value to set the User LEDS 
            EPT_AH_SendByte((byte)1, (byte)0x01);

            //Delay
            Thread.Sleep(1);

            //Send the start Shift Right to the Control Register
            EPT_AH_SendTransferControlByte((byte)2, (byte)0x60);

            //Delay
            Thread.Sleep(1);

            //Send Trigger 7 to latch the Shift-Count  Value
            EPT_AH_SendTrigger((byte)0x80);

            //Set the Button State so User can know which function is selected
            //SetLEDControlButtons(SELECT_SHIFT_RIGHT);


        }

        // Handle GUI update of an incoming block transfer
        public void BlockInReceive()
        {
            //Block Address 4 receives the state of the DueProLogics I/O's
            if (EPTReceiveDevice.Address == 4)
            {
                Thread u = new Thread(new ParameterizedThreadStart(DisplayBlockOut));
                u.Start();
            }

        }

        // Display data from the incoming block of transfer
        public void DisplayBlockOut(object CountData)
        {

            //Increment through each byte received and store in the 
            //appropriate GPIO Register
            uint gpioCount = 0;
            foreach (byte b in EPTReceiveDevice.cBlockBuf)
            {

                switch (gpioCount++)
                {
                    case 0:
                        gpioXIO1 = b;
                        break;
                    case 1:
                        gpioXIO2 = b;
                        break;
                    case 2:
                        gpioXIO3 = b;
                        break;
                    case 3:
                        gpioXIO4 = b;
                        break;
                    case 4:
                        gpioXIO5 = b;
                        break;
                    case 5:
                        gpioXIO6 = b;
                        break;
                    case 6:
                        gpioXIO7 = b;
                        break;
                    case 7:
                        gpioXIO8 = b;
                        break;
                    default: break;
                }

            }
            //Populate each bit in XIO_1 with the appropriate polarity
            gpioBitSelectionXIO_1();

            Thread.Sleep(10);

            //Populate each bit in XIO_2 with the appropriate polarity
            gpioBitSelectionXIO_2();

            Thread.Sleep(10);

            //Populate each bit in XIO_3 with the appropriate polarity
            gpioBitSelectionXIO_3();

            Thread.Sleep(10);

            //Populate each bit in XIO_4 with the appropriate polarity
            gpioBitSelectionXIO_4();

            Thread.Sleep(10);

            //Populate each bit in XIO_5 with the appropriate polarity
            gpioBitSelectionXIO_5();

            Thread.Sleep(10);

            //Populate each bit in XIO_6 with the appropriate polarity
            gpioBitSelectionXIO_6();

            Thread.Sleep(10);

            //Populate each bit in XIO_7 with the appropriate polarity
            gpioBitSelectionXIO_7();

            Thread.Sleep(10);

            //Populate each bit in XIO_8 with the appropriate polarity
            gpioBitSelectionXIO_8();

            Thread.Sleep(10);

        }

        //GPIO Bit Polarity Selection for the XIO1 Connector
        private void gpioBitSelectionXIO_1()
        {
            int index = 0;
            int gpioXIO1_0 = 0;
            int gpioXIO1_1 = 0;
            int gpioXIO1_2 = 0;
            int gpioXIO1_3 = 0;
            int gpioXIO1_4 = 0;
            int gpioXIO1_5 = 0;
            int gpioXIO1_6 = 0;
            int gpioXIO1_7 = 0;


            for (index = 0; index < 8; index++)
            {
                //Set each local pin data to the appropriate data bit from transfer block
                switch (index)
                {
                    case 0:
                        gpioXIO1_0 = ((int)gpioXIO1 & (1 << index));
                        break;
                    case 1:
                        gpioXIO1_1 = ((int)gpioXIO1 & (1 << index));
                        break;
                    case 2:
                        gpioXIO1_2 = ((int)gpioXIO1 & (1 << index));
                        break;
                    case 3:
                        gpioXIO1_3 = ((int)gpioXIO1 & (1 << index));
                        break;
                    case 4:
                        gpioXIO1_4 = ((int)gpioXIO1 & (1 << index));
                        break;
                    case 5:
                        gpioXIO1_5 = ((int)gpioXIO1 & (1 << index));
                        break;
                    case 6:
                        gpioXIO1_6 = ((int)gpioXIO1 & (1 << index));
                        break;
                    case 7:
                        gpioXIO1_7 = ((int)gpioXIO1 & (1 << index));
                        break;
                    default: break;
                }
            }
            //Set the XIO1 Connector Pins to High, Low, Tri
            string s2 = String.Empty;
            if (gpioXIO1_0 == 0x01)
            {
                s2 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO1_1.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO1_1.BackColor = Color.Red;
            }
            else
            {
                s2 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO1_1.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO1_1.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO1_1.Text = s2; }));

            string s3 = String.Empty;
            if (gpioXIO1_1 == 0x02)
            {
                s3 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO1_2.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO1_2.BackColor = Color.Red;
            }
            else
            {
                s3 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO1_2.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO1_2.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO1_2.Text = s3; }));

            string s4 = String.Empty;
            if (gpioXIO1_2 == 0x04)
            {
                s4 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO1_3.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO1_3.BackColor = Color.Red;
            }
            else
            {
                s4 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO1_3.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO1_3.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO1_3.Text = s4; }));

            string s5 = String.Empty;
            if (gpioXIO1_3 == 0x08)
            {
                s5 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO1_4.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO1_4.BackColor = Color.Red;
            }
            else
            {
                s5 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO1_4.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO1_4.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO1_4.Text = s5; }));

            string s6 = String.Empty;
            if (gpioXIO1_4 == 0x10)
            {
                s6 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO1_5.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO1_5.BackColor = Color.Red;
            }
            else
            {
                s6 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO1_5.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO1_5.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO1_5.Text = s6; }));

            string s7 = String.Empty;
            if (gpioXIO1_5 == 0x20)
            {
                s7 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO1_6.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO1_6.BackColor = Color.Red;
            }
            else
            {
                s7 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO1_6.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO1_6.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO1_6.Text = s7; }));

            string s8 = String.Empty;
            if (gpioXIO1_6 == 0x40)
            {
                s8 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO1_7.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO1_7.BackColor = Color.Red;
            }
            else
            {
                s8 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO1_7.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO1_7.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO1_7.Text = s8; }));

            string s9 = String.Empty;
            if (gpioXIO1_7 == 0x80)
            {
                s9 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO1_8.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO1_8.BackColor = Color.Red;
            }
            else
            {
                s9 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO1_8.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO1_8.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO1_8.Text = s9; }));


        }

        //GPIO Bit Polarity Selection for the XIO2 Connector
        private void gpioBitSelectionXIO_2()
        {
            int index = 0;
            int gpioXIO2_0 = 0;
            int gpioXIO2_1 = 0;
            int gpioXIO2_2 = 0;
            int gpioXIO2_3 = 0;
            int gpioXIO2_4 = 0;
            int gpioXIO2_5 = 0;
            int gpioXIO2_6 = 0;
            int gpioXIO2_7 = 0;


            for (index = 0; index < 8; index++)
            {
                //Set each local pin data to the appropriate data bit from transfer block
                switch (index)
                {
                    case 0:
                        gpioXIO2_0 = ((int)gpioXIO2 & (1 << index));
                        break;
                    case 1:
                        gpioXIO2_1 = ((int)gpioXIO2 & (1 << index));
                        break;
                    case 2:
                        gpioXIO2_2 = ((int)gpioXIO2 & (1 << index));
                        break;
                    case 3:
                        gpioXIO2_3 = ((int)gpioXIO2 & (1 << index));
                        break;
                    case 4:
                        gpioXIO2_4 = ((int)gpioXIO2 & (1 << index));
                        break;
                    case 5:
                        gpioXIO2_5 = ((int)gpioXIO2 & (1 << index));
                        break;
                    case 6:
                        gpioXIO2_6 = ((int)gpioXIO2 & (1 << index));
                        break;
                    case 7:
                        gpioXIO2_7 = ((int)gpioXIO2 & (1 << index));
                        break;
                    default: break;
                }
            }
            //Set the XIO2 Connector Pins to High, Low, Tri
            string s2 = String.Empty;
            if (gpioXIO2_0 == 0x01)
            {
                s2 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO2_1.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO2_1.BackColor = Color.Red;
            }
            else
            {
                s2 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO2_1.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO2_1.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO2_1.Text = s2; }));

            string s3 = String.Empty;
            if (gpioXIO2_1 == 0x02)
            {
                s3 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO2_2.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO2_2.BackColor = Color.Red;
            }
            else
            {
                s3 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO2_2.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO2_2.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO2_2.Text = s3; }));

            string s4 = String.Empty;
            if (gpioXIO2_2 == 0x04)
            {
                s4 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO2_3.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO2_3.BackColor = Color.Red;
            }
            else
            {
                s4 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO2_3.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO2_3.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO2_3.Text = s4; }));

            string s5 = String.Empty;
            if (gpioXIO2_3 == 0x08)
            {
                s5 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO2_4.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO2_4.BackColor = Color.Red;
            }
            else
            {
                s5 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO2_4.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO2_4.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO2_4.Text = s5; }));

            string s6 = String.Empty;
            if (gpioXIO2_4 == 0x10)
            {
                s6 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO2_5.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO2_5.BackColor = Color.Red;
            }
            else
            {
                s6 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO2_5.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO2_5.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO2_5.Text = s6; }));

            string s7 = String.Empty;
            if (gpioXIO2_5 == 0x20)
            {
                s7 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO2_6.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO2_6.BackColor = Color.Red;
            }
            else
            {
                s7 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO2_6.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO2_6.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO2_6.Text = s7; }));

            string s8 = String.Empty;
            if (gpioXIO2_6 == 0x40)
            {
                s8 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO2_7.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO2_7.BackColor = Color.Red;
            }
            else
            {
                s8 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO2_7.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO2_7.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO2_7.Text = s8; }));

            string s9 = String.Empty;
            if (gpioXIO2_7 == 0x80)
            {
                s9 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO2_8.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO2_8.BackColor = Color.Red;
            }
            else
            {
                s9 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO2_8.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO2_8.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO2_8.Text = s9; }));


        }

        //GPIO Bit Polarity Selection for the XIO3 Connector
        private void gpioBitSelectionXIO_3()
        {
            int index = 0;
            int gpioXIO3_0 = 0;
            int gpioXIO3_1 = 0;
            int gpioXIO3_2 = 0;
            int gpioXIO3_3 = 0;
            int gpioXIO3_4 = 0;
            int gpioXIO3_5 = 0;
            int gpioXIO3_6 = 0;
            int gpioXIO3_7 = 0;


            for (index = 0; index < 8; index++)
            {
                //Set each local pin data to the appropriate data bit from transfer block
                switch (index)
                {
                    case 0:
                        gpioXIO3_0 = ((int)gpioXIO3 & (1 << index));
                        break;
                    case 1:
                        gpioXIO3_1 = ((int)gpioXIO3 & (1 << index));
                        break;
                    case 2:
                        gpioXIO3_2 = ((int)gpioXIO3 & (1 << index));
                        break;
                    case 3:
                        gpioXIO3_3 = ((int)gpioXIO3 & (1 << index));
                        break;
                    case 4:
                        gpioXIO3_4 = ((int)gpioXIO3 & (1 << index));
                        break;
                    case 5:
                        gpioXIO3_5 = ((int)gpioXIO3 & (1 << index));
                        break;
                    case 6:
                        gpioXIO3_6 = ((int)gpioXIO3 & (1 << index));
                        break;
                    case 7:
                        gpioXIO3_7 = ((int)gpioXIO3 & (1 << index));
                        break;
                    default: break;
                }
            }
            //Set the XIO3 Connector Pins to High, Low, Tri
            string s2 = String.Empty;
            if (gpioXIO3_0 == 0x01)
            {
                s2 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO3_1.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO3_1.BackColor = Color.Red;
            }
            else
            {
                s2 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO3_1.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO3_1.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO3_1.Text = s2; }));

            string s3 = String.Empty;
            if (gpioXIO3_1 == 0x02)
            {
                s3 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO3_2.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO3_2.BackColor = Color.Red;
            }
            else
            {
                s3 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO3_2.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO3_2.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO3_2.Text = s3; }));

            string s4 = String.Empty;
            if (gpioXIO3_2 == 0x04)
            {
                s4 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO3_3.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO3_3.BackColor = Color.Red;
            }
            else
            {
                s4 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO3_3.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO3_3.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO3_3.Text = s4; }));

            string s5 = String.Empty;
            if (gpioXIO3_3 == 0x08)
            {
                s5 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO3_4.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO3_4.BackColor = Color.Red;
            }
            else
            {
                s5 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO3_4.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO3_4.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO3_4.Text = s5; }));

            string s6 = String.Empty;
            if (gpioXIO3_4 == 0x10)
            {
                s6 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO3_5.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO3_5.BackColor = Color.Red;
            }
            else
            {
                s6 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO3_5.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO3_5.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO3_5.Text = s6; }));

            string s7 = String.Empty;
            if (gpioXIO3_5 == 0x20)
            {
                s7 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO3_6.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO3_6.BackColor = Color.Red;
            }
            else
            {
                s7 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO3_6.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO3_6.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO3_6.Text = s7; }));

            string s8 = String.Empty;
            if (gpioXIO3_6 == 0x40)
            {
                s8 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO3_7.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO3_7.BackColor = Color.Red;
            }
            else
            {
                s8 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO3_7.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO3_7.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO3_7.Text = s8; }));

            string s9 = String.Empty;
            if (gpioXIO3_7 == 0x80)
            {
                s9 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO3_8.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO3_8.BackColor = Color.Red;
            }
            else
            {
                s9 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO3_8.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO3_8.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO3_8.Text = s9; }));


        }

        //GPIO Bit Polarity Selection for the XIO4 Connector
        private void gpioBitSelectionXIO_4()
        {
            int index = 0;
            int gpioXIO4_0 = 0;
            int gpioXIO4_1 = 0;
            int gpioXIO4_2 = 0;
            int gpioXIO4_3 = 0;
            int gpioXIO4_4 = 0;
            int gpioXIO4_5 = 0;
            int gpioXIO4_6 = 0;
            int gpioXIO4_7 = 0;


            for (index = 0; index < 8; index++)
            {
                //Set each local pin data to the appropriate data bit from transfer block
                switch (index)
                {
                    case 0:
                        gpioXIO4_0 = ((int)gpioXIO4 & (1 << index));
                        break;
                    case 1:
                        gpioXIO4_1 = ((int)gpioXIO4 & (1 << index));
                        break;
                    case 2:
                        gpioXIO4_2 = ((int)gpioXIO4 & (1 << index));
                        break;
                    case 3:
                        gpioXIO4_3 = ((int)gpioXIO4 & (1 << index));
                        break;
                    case 4:
                        gpioXIO4_4 = ((int)gpioXIO4 & (1 << index));
                        break;
                    case 5:
                        gpioXIO4_5 = ((int)gpioXIO4 & (1 << index));
                        break;
                    case 6:
                        gpioXIO4_6 = ((int)gpioXIO4 & (1 << index));
                        break;
                    case 7:
                        gpioXIO4_7 = ((int)gpioXIO4 & (1 << index));
                        break;
                    default: break;
                }
            }
            //Set the XIO4 Connector Pins to High, Low, Tri
            string s2 = String.Empty;
            if (gpioXIO4_0 == 0x01)
            {
                s2 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO4_1.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO4_1.BackColor = Color.Red;
            }
            else
            {
                s2 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO4_1.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO4_1.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO4_1.Text = s2; }));

            string s3 = String.Empty;
            if (gpioXIO4_1 == 0x02)
            {
                s3 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO4_2.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO4_2.BackColor = Color.Red;
            }
            else
            {
                s3 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO4_2.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO4_2.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO4_2.Text = s3; }));

            string s4 = String.Empty;
            if (gpioXIO4_2 == 0x04)
            {
                s4 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO4_3.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO4_3.BackColor = Color.Red;
            }
            else
            {
                s4 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO4_3.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO4_3.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO4_3.Text = s4; }));

            string s5 = String.Empty;
            if (gpioXIO4_3 == 0x08)
            {
                s5 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO4_4.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO4_4.BackColor = Color.Red;
            }
            else
            {
                s5 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO4_4.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO4_4.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO4_4.Text = s5; }));

            string s6 = String.Empty;
            if (gpioXIO4_4 == 0x10)
            {
                s6 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO4_5.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO4_5.BackColor = Color.Red;
            }
            else
            {
                s6 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO4_5.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO4_5.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO4_5.Text = s6; }));

            string s7 = String.Empty;
            if (gpioXIO4_5 == 0x20)
            {
                s7 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO4_6.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO4_6.BackColor = Color.Red;
            }
            else
            {
                s7 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO4_6.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO4_6.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO4_6.Text = s7; }));

            string s8 = String.Empty;
            if (gpioXIO4_6 == 0x40)
            {
                s8 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO4_7.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO4_7.BackColor = Color.Red;
            }
            else
            {
                s8 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO4_7.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO4_7.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO4_7.Text = s8; }));

            string s9 = String.Empty;
            if (gpioXIO4_7 == 0x80)
            {
                s9 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO4_8.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO4_8.BackColor = Color.Red;
            }
            else
            {
                s9 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO4_8.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO4_8.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO4_8.Text = s9; }));


        }

        //GPIO Bit Polarity Selection for the XIO5 Connector
        private void gpioBitSelectionXIO_5()
        {
            int index = 0;
            int gpioXIO5_0 = 0;
            int gpioXIO5_1 = 0;
            int gpioXIO5_2 = 0;
            int gpioXIO5_3 = 0;
            int gpioXIO5_4 = 0;
            int gpioXIO5_5 = 0;
            int gpioXIO5_6 = 0;
            int gpioXIO5_7 = 0;


            for (index = 0; index < 8; index++)
            {
                //Set each local pin data to the appropriate data bit from transfer block
                switch (index)
                {
                    case 0:
                        gpioXIO5_0 = ((int)gpioXIO5 & (1 << index));
                        break;
                    case 1:
                        gpioXIO5_1 = ((int)gpioXIO5 & (1 << index));
                        break;
                    case 2:
                        gpioXIO5_2 = ((int)gpioXIO5 & (1 << index));
                        break;
                    case 3:
                        gpioXIO5_3 = ((int)gpioXIO5 & (1 << index));
                        break;
                    case 4:
                        gpioXIO5_4 = ((int)gpioXIO5 & (1 << index));
                        break;
                    case 5:
                        gpioXIO5_5 = ((int)gpioXIO5 & (1 << index));
                        break;
                    case 6:
                        gpioXIO5_6 = ((int)gpioXIO5 & (1 << index));
                        break;
                    case 7:
                        gpioXIO5_7 = ((int)gpioXIO5 & (1 << index));
                        break;
                    default: break;
                }
            }
            //Set the XIO5 Connector Pins to High, Low, Tri
            string s2 = String.Empty;
            if (gpioXIO5_0 == 0x01)
            {
                s2 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO5_1.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO5_1.BackColor = Color.Red;
            }
            else
            {
                s2 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO5_1.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO5_1.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO5_1.Text = s2; }));

            string s3 = String.Empty;
            if (gpioXIO5_1 == 0x02)
            {
                s3 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO5_2.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO5_2.BackColor = Color.Red;
            }
            else
            {
                s3 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO5_2.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO5_2.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO5_2.Text = s3; }));

            string s4 = String.Empty;
            if (gpioXIO5_2 == 0x04)
            {
                s4 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO5_3.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO5_3.BackColor = Color.Red;
            }
            else
            {
                s4 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO5_3.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO5_3.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO5_3.Text = s4; }));

            string s5 = String.Empty;
            if (gpioXIO5_3 == 0x08)
            {
                s5 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO5_4.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO5_4.BackColor = Color.Red;
            }
            else
            {
                s5 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO5_4.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO5_4.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO5_4.Text = s5; }));

            string s6 = String.Empty;
            if (gpioXIO5_4 == 0x10)
            {
                s6 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO5_5.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO5_5.BackColor = Color.Red;
            }
            else
            {
                s6 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO5_5.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO5_5.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO5_5.Text = s6; }));

            string s7 = String.Empty;
            if (gpioXIO5_5 == 0x20)
            {
                s7 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO5_6.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO5_6.BackColor = Color.Red;
            }
            else
            {
                s7 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO5_6.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO5_6.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO5_6.Text = s7; }));

            string s8 = String.Empty;
            if (gpioXIO5_6 == 0x40)
            {
                s8 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO5_7.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO5_7.BackColor = Color.Red;
            }
            else
            {
                s8 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO5_7.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO5_7.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO5_7.Text = s8; }));

            string s9 = String.Empty;
            if (gpioXIO5_7 == 0x80)
            {
                s9 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO5_8.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO5_8.BackColor = Color.Red;
            }
            else
            {
                s9 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO5_8.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO5_8.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO5_8.Text = s9; }));


        }

        //GPIO Bit Polarity Selection for the XIO6 Connector
        private void gpioBitSelectionXIO_6()
        {
            int index = 0;
            int gpioXIO6_0 = 0;
            int gpioXIO6_1 = 0;
            int gpioXIO6_2 = 0;
            int gpioXIO6_3 = 0;
            int gpioXIO6_4 = 0;
            int gpioXIO6_5 = 0;
            int gpioXIO6_6 = 0;
            int gpioXIO6_7 = 0;


            for (index = 0; index < 8; index++)
            {
                //Set each local pin data to the appropriate data bit from transfer block
                switch (index)
                {
                    case 0:
                        gpioXIO6_0 = ((int)gpioXIO6 & (1 << index));
                        break;
                    case 1:
                        gpioXIO6_1 = ((int)gpioXIO6 & (1 << index));
                        break;
                    case 2:
                        gpioXIO6_2 = ((int)gpioXIO6 & (1 << index));
                        break;
                    case 3:
                        gpioXIO6_3 = ((int)gpioXIO6 & (1 << index));
                        break;
                    case 4:
                        gpioXIO6_4 = ((int)gpioXIO6 & (1 << index));
                        break;
                    case 5:
                        gpioXIO6_5 = ((int)gpioXIO6 & (1 << index));
                        break;
                    case 6:
                        gpioXIO6_6 = ((int)gpioXIO6 & (1 << index));
                        break;
                    case 7:
                        gpioXIO6_7 = ((int)gpioXIO6 & (1 << index));
                        break;
                    default: break;
                }
            }
            //Set the XIO6 Connector Pins to High, Low, Tri
            string s2 = String.Empty;
            if (gpioXIO6_0 == 0x01)
            {
                s2 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO6_1.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO6_1.BackColor = Color.Red;
            }
            else
            {
                s2 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO6_1.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO6_1.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO6_1.Text = s2; }));

            string s3 = String.Empty;
            if (gpioXIO6_1 == 0x02)
            {
                s3 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO6_2.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO6_2.BackColor = Color.Red;
            }
            else
            {
                s3 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO6_2.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO6_2.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO6_2.Text = s3; }));

            string s4 = String.Empty;
            if (gpioXIO6_2 == 0x04)
            {
                s4 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO6_3.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO6_3.BackColor = Color.Red;
            }
            else
            {
                s4 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO6_3.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO6_3.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO6_3.Text = s4; }));

            string s5 = String.Empty;
            if (gpioXIO6_3 == 0x08)
            {
                s5 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO6_4.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO6_4.BackColor = Color.Red;
            }
            else
            {
                s5 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO6_4.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO6_4.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO6_4.Text = s5; }));

            string s6 = String.Empty;
            if (gpioXIO6_4 == 0x10)
            {
                s6 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO6_5.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO6_5.BackColor = Color.Red;
            }
            else
            {
                s6 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO6_5.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO6_5.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO6_5.Text = s6; }));

            string s7 = String.Empty;
            if (gpioXIO6_5 == 0x20)
            {
                s7 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO6_6.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO6_6.BackColor = Color.Red;
            }
            else
            {
                s7 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO6_6.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO6_6.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO6_6.Text = s7; }));

            string s8 = String.Empty;
            if (gpioXIO6_6 == 0x40)
            {
                s8 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO6_7.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO6_7.BackColor = Color.Red;
            }
            else
            {
                s8 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO6_7.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO6_7.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO6_7.Text = s8; }));

            string s9 = String.Empty;
            if (gpioXIO6_7 == 0x80)
            {
                s9 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO6_8.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO6_8.BackColor = Color.Red;
            }
            else
            {
                s9 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO6_8.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO6_8.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO6_8.Text = s9; }));


        }

        //GPIO Bit Polarity Selection for the XIO7 Connector
        private void gpioBitSelectionXIO_7()
        {
            int index = 0;
            int gpioXIO7_0 = 0;
            int gpioXIO7_1 = 0;
            int gpioXIO7_2 = 0;
            int gpioXIO7_3 = 0;
            int gpioXIO7_4 = 0;
            int gpioXIO7_5 = 0;
            int gpioXIO7_6 = 0;
            int gpioXIO7_7 = 0;


            for (index = 0; index < 8; index++)
            {
                //Set each local pin data to the appropriate data bit from transfer block
                switch (index)
                {
                    case 0:
                        gpioXIO7_0 = ((int)gpioXIO7 & (1 << index));
                        break;
                    case 1:
                        gpioXIO7_1 = ((int)gpioXIO7 & (1 << index));
                        break;
                    case 2:
                        gpioXIO7_2 = ((int)gpioXIO7 & (1 << index));
                        break;
                    case 3:
                        gpioXIO7_3 = ((int)gpioXIO7 & (1 << index));
                        break;
                    case 4:
                        gpioXIO7_4 = ((int)gpioXIO7 & (1 << index));
                        break;
                    case 5:
                        gpioXIO7_5 = ((int)gpioXIO7 & (1 << index));
                        break;
                    case 6:
                        gpioXIO7_6 = ((int)gpioXIO7 & (1 << index));
                        break;
                    case 7:
                        gpioXIO7_7 = ((int)gpioXIO7 & (1 << index));
                        break;
                    default: break;
                }
            }
            //Set the XIO7 Connector Pins to High, Low, Tri
            string s2 = String.Empty;
            if (gpioXIO7_0 == 0x01)
            {
                s2 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO7_1.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO7_1.BackColor = Color.Red;
            }
            else
            {
                s2 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO7_1.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO7_1.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO7_1.Text = s2; }));

            string s3 = String.Empty;
            if (gpioXIO7_1 == 0x02)
            {
                s3 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO7_2.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO7_2.BackColor = Color.Red;
            }
            else
            {
                s3 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO7_2.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO7_2.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO7_2.Text = s3; }));

            string s4 = String.Empty;
            if (gpioXIO7_2 == 0x04)
            {
                s4 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO7_3.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO7_3.BackColor = Color.Red;
            }
            else
            {
                s4 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO7_3.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO7_3.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO7_3.Text = s4; }));

            string s5 = String.Empty;
            if (gpioXIO7_3 == 0x08)
            {
                s5 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO7_4.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO7_4.BackColor = Color.Red;
            }
            else
            {
                s5 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO7_4.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO7_4.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO7_4.Text = s5; }));

            string s6 = String.Empty;
            if (gpioXIO7_4 == 0x10)
            {
                s6 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO7_5.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO7_5.BackColor = Color.Red;
            }
            else
            {
                s6 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO7_5.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO7_5.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO7_5.Text = s6; }));

            string s7 = String.Empty;
            if (gpioXIO7_5 == 0x20)
            {
                s7 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO7_6.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO7_6.BackColor = Color.Red;
            }
            else
            {
                s7 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO7_6.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO7_6.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO7_6.Text = s7; }));

            string s8 = String.Empty;
            if (gpioXIO7_6 == 0x40)
            {
                s8 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO7_7.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO7_7.BackColor = Color.Red;
            }
            else
            {
                s8 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO7_7.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO7_7.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO7_7.Text = s8; }));

            string s9 = String.Empty;
            if (gpioXIO7_7 == 0x80)
            {
                s9 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO7_8.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO7_8.BackColor = Color.Red;
            }
            else
            {
                s9 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO7_8.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO7_8.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO7_8.Text = s9; }));


        }

        //GPIO Bit Polarity Selection for the XIO8 Connector
        private void gpioBitSelectionXIO_8()
        {
            int index = 0;
            int gpioXIO8_0 = 0;
            int gpioXIO8_1 = 0;
            int gpioXIO8_2 = 0;
            int gpioXIO8_3 = 0;
            int gpioXIO8_4 = 0;
            int gpioXIO8_5 = 0;
            int gpioXIO8_6 = 0;
            int gpioXIO8_7 = 0;


            for (index = 0; index < 8; index++)
            {
                //Set each local pin data to the appropriate data bit from transfer block
                switch (index)
                {
                    case 0:
                        gpioXIO8_0 = ((int)gpioXIO8 & (1 << index));
                        break;
                    case 1:
                        gpioXIO8_1 = ((int)gpioXIO8 & (1 << index));
                        break;
                    case 2:
                        gpioXIO8_2 = ((int)gpioXIO8 & (1 << index));
                        break;
                    case 3:
                        gpioXIO8_3 = ((int)gpioXIO8 & (1 << index));
                        break;
                    case 4:
                        gpioXIO8_4 = ((int)gpioXIO8 & (1 << index));
                        break;
                    case 5:
                        gpioXIO8_5 = ((int)gpioXIO8 & (1 << index));
                        break;
                    case 6:
                        gpioXIO8_6 = ((int)gpioXIO8 & (1 << index));
                        break;
                    case 7:
                        gpioXIO8_7 = ((int)gpioXIO8 & (1 << index));
                        break;
                    default: break;
                }
            }
            //Set the XIO8 Connector Pins to High, Low, Tri
            string s2 = String.Empty;
            if (gpioXIO8_0 == 0x01)
            {
                s2 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO8_1.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO8_1.BackColor = Color.Red;
            }
            else
            {
                s2 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO8_1.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO8_1.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO8_1.Text = s2; }));

            string s3 = String.Empty;
            if (gpioXIO8_1 == 0x02)
            {
                s3 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO8_2.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO8_2.BackColor = Color.Red;
            }
            else
            {
                s3 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO8_2.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO8_2.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO8_2.Text = s3; }));

            string s4 = String.Empty;
            if (gpioXIO8_2 == 0x04)
            {
                s4 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO8_3.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO8_3.BackColor = Color.Red;
            }
            else
            {
                s4 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO8_3.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO8_3.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO8_3.Text = s4; }));

            string s5 = String.Empty;
            if (gpioXIO8_3 == 0x08)
            {
                s5 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO8_4.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO8_4.BackColor = Color.Red;
            }
            else
            {
                s5 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO8_4.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO8_4.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO8_4.Text = s5; }));

            string s6 = String.Empty;
            if (gpioXIO8_4 == 0x10)
            {
                s6 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO8_5.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO8_5.BackColor = Color.Red;
            }
            else
            {
                s6 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO8_5.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO8_5.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO8_5.Text = s6; }));

            string s7 = String.Empty;
            if (gpioXIO8_5 == 0x20)
            {
                s7 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO8_6.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO8_6.BackColor = Color.Red;
            }
            else
            {
                s7 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO8_6.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO8_6.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO8_6.Text = s7; }));

            string s8 = String.Empty;
            if (gpioXIO8_6 == 0x40)
            {
                s8 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO8_7.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO8_7.BackColor = Color.Red;
            }
            else
            {
                s8 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO8_7.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO8_7.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO8_7.Text = s8; }));

            string s9 = String.Empty;
            if (gpioXIO8_7 == 0x80)
            {
                s9 = char.ConvertFromUtf32(0x2191);
                btnGPIOXIO8_8.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO8_8.BackColor = Color.Red;
            }
            else
            {
                s9 = char.ConvertFromUtf32(0x2193);
                btnGPIOXIO8_8.ForeColor = System.Drawing.Color.FromArgb(255, 255, 255);
                btnGPIOXIO8_8.BackColor = Color.DodgerBlue;
            }

            this.Invoke(new MethodInvoker(delegate () { btnGPIOXIO8_8.Text = s9; }));


        }


        //Timer1 tick maintains the global counter for Hyper Serial Port
        private void timerDevice_Tick(object sender, EventArgs e)
        {
            if (FT220xSerialPort.IsOpen)
            {
                gpioInifiniteLoopExecute();

            }

        }

        private void gpioInifiniteLoopExecute()
        {
            //EPT_AH_SendTrigger((byte)255); TRIGGER_IN_BYTE_80
            EPT_AH_SendTrigger(TRIGGER_IN_BYTE_80);

        }
        private void rbGPIOInfiniteLoop_CheckedChanged(object sender, EventArgs e)
        {
            gpioInfiniteLoopFlag = true;
            gpioSingleLoopFlag = false;
            gpioInfiniteLoopEnabled = false;

        }

        private void rbGPIOSingleLoop_CheckedChanged(object sender, EventArgs e)
        {
            gpioInfiniteLoopFlag = false;
            gpioSingleLoopFlag = true;
            gpioInfiniteLoopEnabled = false;

        }

        private void btnGPIOReadAll_Click(object sender, EventArgs e)
        {
            gpioReadAllPins();

        }


        public void gpioReadAllPins()
        {


            Thread.Sleep(10);

            if (gpioSingleLoopFlag)
            {

                EPT_AH_SendTrigger(TRIGGER_IN_BYTE_80);

            }
            else if (gpioInfiniteLoopFlag & !gpioInfiniteLoopEnabled)
            {
                btnGPIOReadAll.Text = "Stop";
                gpioInfiniteLoopEnabled = true;
                //Set timerDevice to Enabled to start the infinite loop
                if (!timerDevice.Enabled)
                    timerDevice.Enabled = true;

            }
            else if (gpioInfiniteLoopFlag & gpioInfiniteLoopEnabled)
            {
                btnGPIOReadAll.Text = "Start";
                gpioInfiniteLoopEnabled = false;
                //Set timerDevice to dis-abled, exit the inifite loop
                if (timerDevice.Enabled)
                    timerDevice.Enabled = false;

            }



        }

        private void btnDisplayShiftLeft_Click(object sender, EventArgs e)
        {
            //LoadTimerValue();

            //Send a Reset to Active Transfer Addr 1
            //EPT_AH_SendByte((byte)1, (byte)0x08);

            //Send Trigger 1 to Complete the Reset
            //EPT_AH_SendTrigger((byte)0x01);

            //Send the start to LED Display the Control Register
            EPT_AH_SendTransferControlByte((byte)2, (byte)0x07);

            //Delay
            Thread.Sleep(1);

            //Send the start Shift Left to the Control Register
            EPT_AH_SendTransferControlByte((byte)2, (byte)0x02);

            //Delay
            Thread.Sleep(1);


        }

        private void btnDisplayShiftRight_Click(object sender, EventArgs e)
        {
            //LoadTimerValue();

            //Send a Reset to Active Transfer Addr 1
            //EPT_AH_SendByte((byte)1, (byte)0x08);

            //Send Trigger 1 to Complete the Reset
            //EPT_AH_SendTrigger((byte)0x01);

            //Send the start to LED Display the Control Register
            EPT_AH_SendTransferControlByte((byte)2, (byte)0x07);

            //Send the start Shift Right to LED Display the Control Register
            EPT_AH_SendTransferControlByte((byte)2, (byte)0x03);

            //Delay
            Thread.Sleep(1);


        }

        private void btnDisplayShiftBlink_Click(object sender, EventArgs e)
        {
            //LoadTimerValue();

            //Send a Reset to Active Transfer Addr 1
            //EPT_AH_SendByte((byte)1, (byte)0x08);

            //Send Trigger 1 to Complete the Reset
            //EPT_AH_SendTrigger((byte)0x01);

            //Send the start to LED Display the Control Register
            EPT_AH_SendTransferControlByte((byte)2, (byte)0x07);

            //Send the start Blink to the LED Display Control Register
            EPT_AH_SendTransferControlByte((byte)2, (byte)0x04);

            //Delay
            Thread.Sleep(1);


        }

        private void btnDisplayStop_Click(object sender, EventArgs e)
        {
            //LoadTimerValue();

            //Send a Reset to Active Transfer Addr 1
            //EPT_AH_SendByte((byte)1, (byte)0x08);

            //Send Trigger 1 to Complete the Reset
            //EPT_AH_SendTrigger((byte)0x01);

            //Send the Stop to the LED Display Control Register
            EPT_AH_SendTransferControlByte((byte)2, (byte)0x08);

            //Delay
            Thread.Sleep(1);


        }
    }


    // Transfer object definition
    public class Transfer
    {
        public int Command;
        public int Address;
        public int Length;
        public int Payload;
        public byte[] cBlockBuf;
        public bool TransferPending;
        public uint Repititions;

        public Transfer()
        {
            Command = 0;
            Address = 0;
            Length = 0;
            Payload = 0;
            TransferPending = false;
            Repititions = 0;
        }

    }

}
